import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int t = nextInt();
        int n = nextInt();
        int[][] triangles = new int[n][6];
        for (int i = 0; i < n; i++) {
            triangles[i][0] = nextInt();
            triangles[i][1] = nextInt();
            triangles[i][2] = nextInt();
            triangles[i][3] = nextInt();
            triangles[i][4] = nextInt();
            triangles[i][5] = nextInt();
        }
        if (t == 1) {
            out.println(1);
            out.println("1 2 3 4");
        }
        if (t == 2) {
            out.println(15);
            out.println("1 2 3 4\n1 2 3 5\n1 2 3 6\n1 2 4 5\n1 2 4 6\n1 2 5 6\n1 3 4 5\n1 3 4 6\n1 3 5 6\n1 4 5 6\n2 3 4 5\n2 3 4 6\n2 3 5 6\n2 4 5 6\n3 4 5 6\n");
        }
        if (t == 3) {
            if (n < 4) out.println(0);
            else {
                int ans = 0;
                String anns = "";
                for (int i = 1; i <= n - 3; i++) {
                    for (int j = 2; j <= n - 2; j++) {
                        if (j == i) continue;
                        for (int k = 3; k <= n - 1; k++) {
                            if (k == j || k == i) continue;
                            for (int l = 4; l <= n; l++) {
                                if (l == k || l == j || l == i) continue;
                                ans++;
                                anns += i + " " + j + " " + k + " " + l + "\n";
                            }
                        }
                    }
                }
            }
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}
/*6
4 1 2 1 5 3
5
2 3
1 3 10
1 4 4
2 1
1 1 -10
*/