import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int[] array = new int[n];
        long sum = 0;
        for (int i = 0; i < n; i++) {
            array[i] = nextInt();
            sum += array[i];
        }
        int add = 0;
        int q = nextInt();
        for (int i = 0; i < q; i++) {
            int command = nextInt();
            if (command == 1) {
                int index = nextInt() - 1;
                if (index > add) {
                    index += add;
                    index = index % n;
                } else {
                    index += n - add;
                    index = index % n;
                }
                int x = nextInt();
                sum += x - array[index];
                array[index] = x;
            } else {
                int k = nextInt();
                add += k;
                add = add % n;
            }
            out.println(sum);
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}
/*6
4 1 2 1 5 3
5
2 3
1 3 10
1 4 4
2 1
1 1 -10
*/