import java.awt.*;
import java.io.*;
import java.util.*;

public class Main {
    public static int counter(int n, int a) {
        return n - a + 1;
    }

    public static int euclid(int a, int b) {
        if (a <= b) return b;
        return euclid(Math.max(a - b, b), Math.min(a - b, b));
    }

    public static void main(String[] args) throws IOException {
        int n = nextInt(), k = nextInt();
        int a[] = new int[n - 1];
        for (int i = 0; i < n - 1; i++) {
            a[i] = nextInt();
            nextInt();
        }
        int strike = 1;
        int ans = 0;
        for (int i = 1; i < n - 1; i++) {
            if (a[i - 1] != a[i]) {
                if (strike > k) ans += k;
                else ans += strike % k;
                strike = 1;
            }
            strike++;
        }
        out.println(ans + " " + 0);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}